﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make an array of Persons.
        Dim people() As Person = { _
            New Person() With {.FirstName = "Alice", .LastName = "Archer"}, _
            New Person() With {.FirstName = "Ben", .LastName = "Balk"}, _
            New Person() With {.FirstName = "Cindy", .LastName = "Carter"}, _
            New Person() With {.FirstName = "Dean", .LastName = "Dent"}, _
            New Person() With {.FirstName = "Ermintrude", .LastName = "Eag"} _
        }

        ' Display the People in the ListBox.
        lstPeople.DataSource = people

        ' Make an array of Students.
        Dim students() As Student = { _
            New Student() With {.FirstName = "Alice", .LastName = "Archer"}, _
            New Student() With {.FirstName = "Ben", .LastName = "Balk"}, _
            New Student() With {.FirstName = "Cindy", .LastName = "Carter"}, _
            New Student() With {.FirstName = "Dean", .LastName = "Dent"}, _
            New Student() With {.FirstName = "Ermintrude", .LastName = "Eag"} _
        }

        ' Display the Students in the ListBox.
        lstStudents.DataSource = students

        ' Rearrange the ListBoxes.
        Form1_Resize(Nothing, Nothing)
    End Sub

    ' Divide the available space between the ListBoxes.
    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim wid As Integer = (Me.ClientSize.Width - 5) \ 2
        If (wid < 20) Then wid = 20
        Dim hgt As Integer = Me.ClientSize.Height

        lstPeople.SetBounds(0, 0, wid, hgt)
        lstStudents.SetBounds(wid + 5, 0, wid, hgt)
    End Sub
End Class

Public Class Person
    ' Properties.
    Private m_FirstName As String
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    Private m_LastName As String
    Public Property LastName() As String
        Get
            Return m_LastName
        End Get
        Set(ByVal value As String)
            m_LastName = value
        End Set
    End Property
End Class

Public Class Student
    Inherits Person

    ' Override ToString.
    Public Overrides Function ToString() As String
        Return FirstName & " " & LastName
    End Function
End Class
